## glaze 4.4.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21)

include(cmake/prelude.cmake)

project(
    glaze
    VERSION 4.4.3
    LANGUAGES CXX
)

include(cmake/project-is-top-level.cmake)
include(cmake/variables.cmake)

add_library(glaze_glaze INTERFACE)
add_library(glaze::glaze ALIAS glaze_glaze)


if (MSVC)
  string(REGEX MATCH "\/cl(.exe)?$" matched_cl ${CMAKE_CXX_COMPILER})
  if (matched_cl)
    # for a C++ standards compliant preprocessor, not needed for clang-cl
    target_compile_options(glaze_glaze INTERFACE "/Zc:preprocessor" /permissive- /Zc:lambda)
    
    if(PROJECT_IS_TOP_LEVEL)
      target_compile_options(glaze_glaze INTERFACE 
        $<$<CONFIG:Release>:/GL>
        $<$<CONFIG:MinSizeRel>:/GL>)
      target_link_options(glaze_glaze INTERFACE 
        $<$<CONFIG:Release>:/LTCG /INCREMENTAL:NO>
        $<$<CONFIG:MinSizeRel>:/LTCG /INCREMENTAL:NO>)
    endif()
   endif()
else()
  target_compile_options(glaze_glaze INTERFACE "-Wno-missing-braces")
endif()

set_property(TARGET glaze_glaze PROPERTY EXPORT_NAME glaze)

target_compile_features(glaze_glaze INTERFACE cxx_std_23)
target_include_directories(
    glaze_glaze ${warning_guard}
    INTERFACE "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>"
)

if(NOT CMAKE_SKIP_INSTALL_RULES)
  include(cmake/install-rules.cmake)
endif()

if (glaze_DEVELOPER_MODE)
  include(cmake/dev-mode.cmake)
endif()

option(glaze_DISABLE_SIMD_WHEN_SUPPORTED
       "disable SIMD optimizations even when targets support it (e.g. AVX2)" OFF)
if(glaze_DISABLE_SIMD_WHEN_SUPPORTED)
  target_compile_definitions(glaze_glaze INTERFACE GLZ_DISABLE_SIMD)
endif()

option(glaze_BUILD_EXAMPLES "Build GLAZE examples" OFF)

if(glaze_BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

=== tests/asio_repe/CMakeLists.txt ===
project(asio_repe)

FetchContent_Declare(
    asio
    GIT_REPOSITORY https://github.com/chriskohlhoff/asio.git
    GIT_TAG asio-1-30-1
    GIT_SHALLOW TRUE
)
FetchContent_MakeAvailable(asio)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_include_directories(${PROJECT_NAME} PRIVATE include ${asio_SOURCE_DIR}/asio/include)
target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_exceptions)

=== tests/eigen_test/CMakeLists.txt ===
project(eigen_test)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

find_package (Eigen3 3.4 QUIET)
if(NOT Eigen3_FOUND)
  FetchContent_Declare(
    Eigen3
    GIT_REPOSITORY https://gitlab.com/libeigen/eigen.git
    GIT_TAG 3.4.0
    GIT_SHALLOW TRUE
  )
  FetchContent_GetProperties(Eigen3)
  if(NOT eigen3_POPULATED)
    FetchContent_Populate(Eigen3)
    add_library(Eigen3 INTERFACE IMPORTED GLOBAL)
    add_library(Eigen3::Eigen ALIAS Eigen3)
    target_include_directories(Eigen3 INTERFACE "${eigen3_SOURCE_DIR}")
  endif()
endif()

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_common Eigen3::Eigen)

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

target_code_coverage(${PROJECT_NAME} AUTO ALL)

=== debian/changelog ===
glaze (4.4.3-1) unstable; urgency=medium

  * Initial release. (Closes: #1098764)

 -- Carl Keinath <carl.keinath@gmail.com>  Tue, 25 Feb 2025 12:04:13 +0100

=== debian/control ===
Source: glaze
Section: libs
Priority: optional
Maintainer: Carl Keinath <carl.keinath@gmail.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake
Standards-Version: 4.7.0
Homepage: https://github.com/stephenberry/glaze/tree/main
Vcs-Browser: https://salsa.debian.org/carlo711/glaze
Vcs-Git: https://salsa.debian.org/carlo711/glaze.git
Description: High-performance C++ JSON serialization library
 Glaze is a high-performance C++ library for JSON and other structured formats,
 it provides efficient serialization and deserialization.

Package: libglaze-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: ${source:Synopsis} - development files
 ${source:Extended-Description}
 .
 Note: This package only supports little-endian systems.

## glaze 5.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 project(
     glaze
-    VERSION 4.4.3
+    VERSION 5.5.2
     LANGUAGES CXX
 )
 
@@ -31,14 +31,14 @@
     endif()
    endif()
 else()
-  target_compile_options(glaze_glaze INTERFACE "-Wno-missing-braces")
+  target_compile_options(${PROJECT_NAME}_${PROJECT_NAME} INTERFACE "-Wno-missing-braces")
 endif()
 
-set_property(TARGET glaze_glaze PROPERTY EXPORT_NAME glaze)
+set_property(TARGET ${PROJECT_NAME}_${PROJECT_NAME} PROPERTY EXPORT_NAME glaze)
 
-target_compile_features(glaze_glaze INTERFACE cxx_std_23)
+target_compile_features(${PROJECT_NAME}_${PROJECT_NAME} INTERFACE cxx_std_23)
 target_include_directories(
-    glaze_glaze ${warning_guard}
+    ${PROJECT_NAME}_${PROJECT_NAME} ${warning_guard}
     INTERFACE "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>"
 )
 
@@ -61,3 +61,30 @@
 if(glaze_BUILD_EXAMPLES)
   add_subdirectory(examples)
 endif()
+
+option(glaze_EETF_FORMAT "Enable Erlang external term format parsing" OFF)
+
+if(glaze_EETF_FORMAT)
+  list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
+  find_package(Erlang REQUIRED)
+  target_link_libraries(
+    glaze_glaze ${warning_guard}
+    INTERFACE
+      Erlang::EI
+      Erlang::Erlang
+  )
+  target_compile_definitions(glaze_glaze INTERFACE GLZ_ENABLE_EETF)
+endif(glaze_EETF_FORMAT)
+
+option(glaze_ENABLE_SSL "Enable SSL/TLS support for HTTPS servers" OFF)
+
+if(glaze_ENABLE_SSL)
+  find_package(OpenSSL REQUIRED)
+  target_link_libraries(
+    glaze_glaze ${warning_guard}
+    INTERFACE
+      OpenSSL::SSL
+      OpenSSL::Crypto
+  )
+  target_compile_definitions(glaze_glaze INTERFACE GLZ_ENABLE_SSL)
+endif(glaze_ENABLE_SSL)

=== tests/networking_tests/CMakeLists.txt ===
FetchContent_Declare(
    asio
    GIT_REPOSITORY https://github.com/chriskohlhoff/asio.git
    GIT_TAG asio-1-32-0
    GIT_SHALLOW TRUE
)
FetchContent_MakeAvailable(asio)

# HTTP Examples
add_subdirectory(http_examples)

# Networking Tests
add_subdirectory(asio_repe)
add_subdirectory(http_router_test)
add_subdirectory(http_client_test)
add_subdirectory(http_server_api_tests)
add_subdirectory(https_test)
add_subdirectory(repe_test)
add_subdirectory(rest_test)
add_subdirectory(websocket_test)

=== tests/networking_tests/https_test/CMakeLists.txt ===
# HTTPS Test CMakeLists.txt
cmake_minimum_required(VERSION 3.21)
project(https_test)

# Only build if OpenSSL is available
find_package(OpenSSL REQUIRED)

FetchContent_Declare(
    asio
    GIT_REPOSITORY https://github.com/chriskohlhoff/asio.git
    GIT_TAG asio-1-32-0
    GIT_SHALLOW TRUE
)
FetchContent_MakeAvailable(asio)

# Test if we can actually compile with OpenSSL headers
include(CheckCXXSourceCompiles)
set(CMAKE_REQUIRED_LIBRARIES OpenSSL::SSL OpenSSL::Crypto)
check_cxx_source_compiles("
    #include <openssl/ssl.h>
    #include <openssl/opensslconf.h>
    #include <openssl/evp.h>
    #include <openssl/x509.h>
    #include <openssl/pem.h>
    int main() { return 0; }
" OPENSSL_HEADERS_AVAILABLE)

if(OPENSSL_HEADERS_AVAILABLE)
    add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)
    target_link_libraries(${PROJECT_NAME}
        PRIVATE
        glz_test_exceptions
        OpenSSL::SSL
        OpenSSL::Crypto
    )
    target_compile_definitions(${PROJECT_NAME} PRIVATE GLZ_ENABLE_SSL)
    target_include_directories(${PROJECT_NAME} PRIVATE include ${asio_SOURCE_DIR}/asio/include)
    target_compile_definitions(${PROJECT_NAME} PRIVATE SOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}")

    # Set C++ standard
    target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_23)
    
    message(STATUS "Self-contained HTTPS test will be built with OpenSSL support")
    message(STATUS " Certificates will be generated automatically at runtime")
else()
    message(FATAL_ERROR "❌ OpenSSL headers missing - install libssl-dev/openssl-devel")
endif()

=== debian/changelog ===
glaze (5.5.2-1) experimental; urgency=medium

  * New upstream release 5.5.2.
  * Added lrc.config to suppress false license error.

 -- Carl Keinath <carl.keinath@gmail.com>  Sun, 22 Jun 2025 11:23:41 +0200

glaze (5.4.0-1) experimental; urgency=medium

  * New upstream release 5.4.0.
  * Moved repo to debian namespace.

 -- Carl Keinath <carl.keinath@gmail.com>  Fri, 06 Jun 2025 19:44:30 +0200

glaze (5.1.0-1) experimental; urgency=medium

  * New upstream release 5.1.0.
  * Bump Standards-Version to 4.7.2.

 -- Carl Keinath <carl.keinath@gmail.com>  Mon, 21 Apr 2025 09:44:03 +0200

## glaze 5.5.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,12 +4,16 @@
 
 project(
     glaze
-    VERSION 5.5.2
+    VERSION 5.5.4
     LANGUAGES CXX
 )
 
 include(cmake/project-is-top-level.cmake)
 include(cmake/variables.cmake)
+
+if (PROJECT_IS_TOP_LEVEL)
+  set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
+endif()
 
 add_library(glaze_glaze INTERFACE)
 add_library(glaze::glaze ALIAS glaze_glaze)

=== tests/CMakeLists.txt ===
include(FetchContent)

FetchContent_Declare(
  ut
  GIT_REPOSITORY https://github.com/openalgz/ut
  GIT_TAG v1.0.0
  GIT_SHALLOW TRUE
)

message(STATUS "Fetching dependencies...")
set_directory_properties(PROPERTIES EXCLUDE_FROM_ALL TRUE)
set(CMAKE_SKIP_INSTALL_RULES ON CACHE BOOL "" FORCE)
FetchContent_MakeAvailable(ut)
set(CMAKE_SKIP_INSTALL_RULES OFF CACHE BOOL "" FORCE)
set_directory_properties(PROPERTIES EXCLUDE_FROM_ALL FALSE)
message(STATUS "...finished fetching dependencies.")

include(../cmake/code-coverage.cmake)
add_code_coverage_all_targets()

add_library(glz_test_common INTERFACE)
target_compile_features(glz_test_common INTERFACE cxx_std_23)
target_link_libraries(glz_test_common INTERFACE ut::ut glaze::glaze)
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
    target_compile_options(glz_test_common INTERFACE -fno-exceptions -fno-rtti)
    if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
        if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 13)
            target_compile_options(glz_test_common INTERFACE -Wall -Wextra -pedantic)
        else()
            target_compile_options(glz_test_common INTERFACE -Wall -Wextra -pedantic $<$<CONFIG:Debug>:-Werror>)
        endif()
    elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        target_compile_options(glz_test_common INTERFACE -Wall -Wextra -pedantic $<$<CONFIG:Debug>:-Werror>)
    else()
        target_compile_options(glz_test_common INTERFACE -Wall -Wextra -pedantic)
    endif()

    if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
      target_compile_options(glz_test_common INTERFACE -ftime-trace -fsanitize=address -fsanitize-address-use-after-scope -fsanitize=undefined)
      target_link_options(glz_test_common INTERFACE -ftime-trace -fsanitize=address -fsanitize-address-use-after-scope -fsanitize=undefined)
    endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(glz_test_common INTERFACE /GR- /bigobj) #/fsanitize=address
    target_compile_options(glz_test_common INTERFACE /W4 /wd4459 /wd4805)
endif()

add_library(glz_test_exceptions INTERFACE)
target_compile_features(glz_test_exceptions INTERFACE cxx_std_23)
target_link_libraries(glz_test_exceptions INTERFACE ut::ut glaze::glaze)
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
    target_compile_options(glz_test_exceptions INTERFACE)
    target_compile_options(glz_test_exceptions INTERFACE -Wall -Wextra -pedantic)
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(glz_test_exceptions INTERFACE /GR- /bigobj) #/fsanitize=address
    target_compile_options(glz_test_exceptions INTERFACE /W4 /wd4459 /wd4805)
endif()

add_subdirectory(api_test)
add_subdirectory(beve_test)
add_subdirectory(cli_menu_test)
add_subdirectory(compare_test)
add_subdirectory(csv_test)
add_subdirectory(eigen_test)
add_subdirectory(example_json)
add_subdirectory(exceptions_test)
add_subdirectory(inplace_vector)
add_subdirectory(int_parsing)
add_subdirectory(jmespath)
add_subdirectory(jsonrpc_test)
add_subdirectory(lib_test)
add_subdirectory(mock_json_test)
add_subdirectory(reflection)
add_subdirectory(roundtrip)
add_subdirectory(stencil)
add_subdirectory(threading_test)
add_subdirectory(toml_test)
add_subdirectory(utility_formats)

# JSON Tests
add_subdirectory(json_conformance)
add_subdirectory(json_performance)
add_subdirectory(json_reflection_test)
add_subdirectory(json_test)

add_subdirectory(networking_tests)

if(glaze_EETF_FORMAT)
    add_subdirectory(eetf_test)
endif(glaze_EETF_FORMAT)

# We don't run find_package_test or glaze-install_test with MSVC/Windows, because the Github action runner often chokes
# Don't run find_package on Clang, because Linux runs with Clang try to use GCC standard library and have errors before Clang 18
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    add_test(
    NAME glaze-install_test
    COMMAND
    "${CMAKE_COMMAND}"
    --install "${PROJECT_BINARY_DIR}"
    --prefix "${CMAKE_CURRENT_BINARY_DIR}/install"
    --config $<CONFIG>
    --verbose
    )

    add_test(
    NAME find_package_test
    COMMAND
    "${CMAKE_CTEST_COMMAND}"
    --verbose
    --output-on-failure
    --build-noclean
    --build-project "${PROJECT_NAME}" # helps msvc when --build-target
    --build-generator "${CMAKE_GENERATOR}"
    --build-config $<CONFIG>
    --build-and-test
    "${CMAKE_CURRENT_SOURCE_DIR}/find_package"
    "${CMAKE_CURRENT_BINARY_DIR}/find_package"
    --build-options
    "-Dglaze_ROOT:PATH=${CMAKE_CURRENT_BINARY_DIR}/install"
    "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}"
    "-DBUILD_TESTING=ON"
    "$<$<BOOL:${glaze_EETF_FORMAT}>:-Dglaze_EETF_FORMAT=ON>"
    "$<$<BOOL:${glaze_EETF_FORMAT}>:-DEXTERNAL_MODULE_PATH=${PROJECT_SOURCE_DIR}/cmake>"
    --test-command "${CMAKE_CTEST_COMMAND}" --verbose --output-on-failure # inner ctest command
    )

    set_tests_properties(glaze-install_test PROPERTIES FIXTURES_SETUP glaze-install-fixture)
    set_tests_properties(find_package_test PROPERTIES FIXTURES_REQUIRED glaze-install-fixture)
endif()

=== tests/beve_test/CMakeLists.txt ===
project(beve_test)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_common)

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

target_code_coverage(${PROJECT_NAME} AUTO ALL)

=== tests/csv_test/CMakeLists.txt ===
project(csv_test)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_common)

if (MINGW)
    target_compile_options(${PROJECT_NAME} PRIVATE "-Wa,-mbig-obj")
endif ()

target_compile_definitions(${PROJECT_NAME} PRIVATE 
    GLZ_TEST_DIRECTORY="${CMAKE_CURRENT_SOURCE_DIR}"
)

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

target_code_coverage(${PROJECT_NAME} AUTO ALL)

=== tests/int_parsing/CMakeLists.txt ===
project(int_parsing)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_exceptions)

if (MINGW)
    target_compile_options(${PROJECT_NAME} PRIVATE "-Wa,-mbig-obj")
endif ()

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== tests/json_performance/CMakeLists.txt ===
project(json_performance)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_exceptions)

if (MINGW)
    target_compile_options(${PROJECT_NAME} PRIVATE "-Wa,-mbig-obj")
endif ()

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== tests/networking_tests/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
 add_subdirectory(http_client_test)
 add_subdirectory(http_server_api_tests)
 add_subdirectory(https_test)
+add_subdirectory(openapi_test)
 add_subdirectory(repe_test)
 add_subdirectory(rest_test)
 add_subdirectory(websocket_test)

=== tests/stencil/CMakeLists.txt ===
project(stencil_test)

add_compile_definitions(GLZ_TEST_DIRECTORY="${CMAKE_CURRENT_SOURCE_DIR}")

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_common)

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

target_code_coverage(${PROJECT_NAME} AUTO ALL)

=== tests/networking_tests/http_server_api_tests/CMakeLists.txt ===
project(http_server_api_tests)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_include_directories(${PROJECT_NAME} PRIVATE include ${asio_SOURCE_DIR}/asio/include)
target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_exceptions)

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== tests/networking_tests/openapi_test/CMakeLists.txt ===
project(openapi_test)

FetchContent_Declare(
    asio
    GIT_REPOSITORY https://github.com/chriskohlhoff/asio.git
    GIT_TAG asio-1-32-0
    GIT_SHALLOW TRUE
)
FetchContent_MakeAvailable(asio)

add_executable(openapi_test openapi_test.cpp)
target_include_directories(openapi_test PRIVATE include ${asio_SOURCE_DIR}/asio/include)
target_link_libraries(openapi_test PRIVATE glz_test_exceptions)

=== tests/networking_tests/repe_test/CMakeLists.txt ===
project(repe_test)

FetchContent_Declare(
    asio
    GIT_REPOSITORY https://github.com/chriskohlhoff/asio.git
    GIT_TAG asio-1-32-0
    GIT_SHALLOW TRUE
)
FetchContent_MakeAvailable(asio)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_include_directories(${PROJECT_NAME} PRIVATE include ${asio_SOURCE_DIR}/asio/include)
target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_exceptions)

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== tests/networking_tests/rest_test/CMakeLists.txt ===
project(rest_test)

FetchContent_Declare(
    asio
    GIT_REPOSITORY https://github.com/chriskohlhoff/asio.git
    GIT_TAG asio-1-32-0
    GIT_SHALLOW TRUE
)
FetchContent_MakeAvailable(asio)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_include_directories(${PROJECT_NAME} PRIVATE include ${asio_SOURCE_DIR}/asio/include)
target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_exceptions)

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

add_executable(rest_registry_test rest_registry_test.cpp)

target_include_directories(rest_registry_test PRIVATE include ${asio_SOURCE_DIR}/asio/include)
target_link_libraries(rest_registry_test PRIVATE glz_test_exceptions)

add_subdirectory(rest_server)

=== debian/changelog ===
glaze (5.5.4-1) unstable; urgency=medium

  * New upstream release 5.5.4.

 -- Carl Keinath <carl.keinath@gmail.com>  Mon, 28 Jul 2025 10:42:15 +0200

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,10 @@
 Build-Depends:
  debhelper-compat (= 13),
  cmake
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/stephenberry/glaze/tree/main
-Vcs-Browser: https://salsa.debian.org/carlo711/glaze
-Vcs-Git: https://salsa.debian.org/carlo711/glaze.git
+Vcs-Browser: https://salsa.debian.org/debian/glaze
+Vcs-Git: https://salsa.debian.org/debian/glaze.git
 Description: High-performance C++ JSON serialization library
  Glaze is a high-performance C++ library for JSON and other structured formats,
  it provides efficient serialization and deserialization.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-Dglaze_DEVELOPER_MODE=OFF \
	-DBUILD_TESTING=OFF

## glaze 5.5.5

=== debian/changelog ===
glaze (5.5.5-1) unstable; urgency=medium

  * New upstream release 5.5.5.

 -- Carl Keinath <carl.keinath@gmail.com>  Wed, 06 Aug 2025 17:43:12 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Section: libs
 Priority: optional
 Maintainer: Carl Keinath <carl.keinath@gmail.com>
-Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
  cmake

## glaze 5.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 project(
     glaze
-    VERSION 5.5.4
+    VERSION 5.6.0
     LANGUAGES CXX
 )
 
@@ -92,3 +92,9 @@
   )
   target_compile_definitions(glaze_glaze INTERFACE GLZ_ENABLE_SSL)
 endif(glaze_ENABLE_SSL)
+
+option(glaze_BUILD_INTEROP "Build language interoperability library" OFF)
+
+if(glaze_BUILD_INTEROP)
+  add_subdirectory(src/interop)
+endif()

=== tests/interop/CMakeLists.txt ===
# Build plugin libraries needed for tests
add_library(simple_plugin SHARED test_plugin_minimal.cpp)
target_compile_features(simple_plugin PRIVATE cxx_std_17)
set_target_properties(simple_plugin PROPERTIES
    POSITION_INDEPENDENT_CODE ON
    CXX_VISIBILITY_PRESET default
    VISIBILITY_INLINES_HIDDEN OFF
)

add_library(complex_structures_plugin SHARED test_plugin_complex_structures.cpp)
target_compile_features(complex_structures_plugin PRIVATE cxx_std_23)
set_target_properties(complex_structures_plugin PROPERTIES
    POSITION_INDEPENDENT_CODE ON
    CXX_VISIBILITY_PRESET default
    VISIBILITY_INLINES_HIDDEN OFF
)

# Basic interop functionality test
project(interop_basic_test)
add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)
target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_common)
add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

# Plugin functionality test
project(interop_plugins_test)
add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)
target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_common)
add_dependencies(${PROJECT_NAME} simple_plugin)
add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

# Cross-library structures test
project(interop_structures_test)
add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)
target_link_libraries(${PROJECT_NAME} PRIVATE glaze_interop glaze_interop_client glz_test_common)
add_dependencies(${PROJECT_NAME} complex_structures_plugin)
add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

# Pure C FFI test - demonstrates C interface works without C++ templates
project(test_c_ffi)
add_executable(${PROJECT_NAME} test_c_ffi.c)
set_target_properties(${PROJECT_NAME} PROPERTIES C_STANDARD 11)
target_link_libraries(${PROJECT_NAME} PRIVATE glaze_interop)
add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

# Comprehensive optional types test
project(interop_optional_test)
add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)
target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_23)
target_link_libraries(${PROJECT_NAME} PRIVATE glaze_interop glaze_interop_client glaze::glaze ut::ut)
# Set compile options directly without inheriting from glz_test_common
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    target_compile_options(${PROJECT_NAME} PRIVATE -fno-exceptions -fno-rtti -Wall -Wextra -pedantic -Wno-missing-braces)
endif()
add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

# Comprehensive variant types test
project(interop_variant_test)
add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)
target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_23)
target_link_libraries(${PROJECT_NAME} PRIVATE glaze_interop glaze_interop_client glaze::glaze ut::ut)
# Set compile options directly without inheriting from glz_test_common
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    target_compile_options(${PROJECT_NAME} PRIVATE -fno-exceptions -fno-rtti -Wall -Wextra -pedantic -Wno-missing-braces)
endif()
add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

# Variant with struct types test
project(interop_variant_struct_test)
add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)
target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_23)
target_link_libraries(${PROJECT_NAME} PRIVATE glaze_interop glaze_interop_client glaze::glaze ut::ut)
# Set compile options directly without inheriting from glz_test_common
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    target_compile_options(${PROJECT_NAME} PRIVATE -fno-exceptions -fno-rtti -Wall -Wextra -pedantic -Wno-missing-braces)
endif()
add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== tests/jmespath/CMakeLists.txt ===
project(jmespath)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_common)

if (MINGW)
    target_compile_options(${PROJECT_NAME} PRIVATE "-Wa,-mbig-obj")
endif ()

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

target_code_coverage(${PROJECT_NAME} AUTO ALL)

=== tests/json_test/CMakeLists.txt ===
project(json_test)

## Null terminated json_test

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_common)

if (MINGW)
    target_compile_options(${PROJECT_NAME} PRIVATE "-Wa,-mbig-obj")
endif ()

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

target_code_coverage(${PROJECT_NAME} AUTO ALL)

## Non-null terminated json_test

add_executable(${PROJECT_NAME}_non_null ${PROJECT_NAME}.cpp)

target_compile_definitions(${PROJECT_NAME}_non_null PRIVATE GLZ_NULL_TERMINATED=false)

target_link_libraries(${PROJECT_NAME}_non_null PRIVATE glz_test_common)

if (MINGW)
    target_compile_options(${PROJECT_NAME}_non_null PRIVATE "-Wa,-mbig-obj")
endif ()

add_test(NAME ${PROJECT_NAME}_non_null COMMAND ${PROJECT_NAME}_non_null)

## glz::json_t test

add_executable(json_t_test json_t_test.cpp)

target_link_libraries(json_t_test PRIVATE glz_test_common)

add_test(NAME json_t_test COMMAND json_t_test)

## JSON Schema test

add_executable(jsonschema_test jsonschema_test.cpp)

target_link_libraries(jsonschema_test PRIVATE glz_test_common)

add_test(NAME jsonschema_test COMMAND jsonschema_test)

## Variant ambiguous test - test for ambiguous variant handling

add_executable(variant_ambiguous_test variant_ambiguous_test.cpp)

target_link_libraries(variant_ambiguous_test PRIVATE glz_test_common)

add_test(NAME variant_ambiguous_test COMMAND variant_ambiguous_test)

=== tests/networking_tests/rest_test/rest_server/CMakeLists.txt ===
project(rest_server VERSION 1.0 LANGUAGES CXX)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_include_directories(${PROJECT_NAME} PRIVATE ${asio_SOURCE_DIR}/asio/include)
target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_exceptions)

target_compile_definitions(${PROJECT_NAME} PRIVATE 
    SOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}")

=== debian/changelog ===
glaze (5.6.0-1) unstable; urgency=medium

  * New upstream release 5.6.0.
  * Moved repo to personal namespace.

 -- Carl Keinath <carl.keinath@gmail.com>  Wed, 20 Aug 2025 20:36:44 +0200

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
	https://github.com/stephenberry/glaze/tags \
	(?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## glaze 5.6.1

=== debian/changelog ===
glaze (5.6.1-1) unstable; urgency=medium

  * New upstream release 5.6.1.
  * Migrated to debian/watch version 5.

 -- Carl Keinath <carl.keinath@gmail.com>  Sat, 30 Aug 2025 08:48:14 +0200

## glaze 5.7.0

=== debian/changelog ===
glaze (5.7.0-1) unstable; urgency=medium

  * New upstream release 5.7.0.

 -- Carl Keinath <carl.keinath@gmail.com>  Sat, 06 Sep 2025 11:03:24 +0200

## glaze 5.7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 project(
     glaze
-    VERSION 5.6.0
+    VERSION 5.7.2
     LANGUAGES CXX
 )

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
 
 add_library(glz_test_common INTERFACE)
 target_compile_features(glz_test_common INTERFACE cxx_std_23)
-target_link_libraries(glz_test_common INTERFACE ut::ut glaze::glaze)
+target_link_libraries(glz_test_common INTERFACE ut::ut glaze::glaze glz_asio)
 if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
     target_compile_options(glz_test_common INTERFACE -fno-exceptions -fno-rtti)
     if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
@@ -35,7 +35,7 @@
         target_compile_options(glz_test_common INTERFACE -Wall -Wextra -pedantic)
     endif()
 
-    if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+        if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
       target_compile_options(glz_test_common INTERFACE -ftime-trace -fsanitize=address -fsanitize-address-use-after-scope -fsanitize=undefined)
       target_link_options(glz_test_common INTERFACE -ftime-trace -fsanitize=address -fsanitize-address-use-after-scope -fsanitize=undefined)
     endif()
@@ -46,7 +46,7 @@
 
 add_library(glz_test_exceptions INTERFACE)
 target_compile_features(glz_test_exceptions INTERFACE cxx_std_23)
-target_link_libraries(glz_test_exceptions INTERFACE ut::ut glaze::glaze)
+target_link_libraries(glz_test_exceptions INTERFACE ut::ut glaze::glaze glz_asio)
 if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
     target_compile_options(glz_test_exceptions INTERFACE)
     target_compile_options(glz_test_exceptions INTERFACE -Wall -Wextra -pedantic)
@@ -67,6 +67,7 @@
 add_subdirectory(int_parsing)
 add_subdirectory(jmespath)
 add_subdirectory(jsonrpc_test)
+add_subdirectory(key_transformers_test)
 add_subdirectory(lib_test)
 add_subdirectory(mock_json_test)
 add_subdirectory(reflection)
@@ -87,6 +88,10 @@
 if(glaze_EETF_FORMAT)
     add_subdirectory(eetf_test)
 endif(glaze_EETF_FORMAT)
+
+if(glaze_BUILD_INTEROP)
+    add_subdirectory(interop)
+endif(glaze_BUILD_INTEROP)
 
 # We don't run find_package_test or glaze-install_test with MSVC/Windows, because the Github action runner often chokes
 # Don't run find_package on Clang, because Linux runs with Clang try to use GCC standard library and have errors before Clang 18

=== tests/interop/CMakeLists.txt ===
--- 
+++ 
@@ -74,3 +74,43 @@
     target_compile_options(${PROJECT_NAME} PRIVATE -fno-exceptions -fno-rtti -Wall -Wextra -pedantic -Wno-missing-braces)
 endif()
 add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})
+
+# Complex types interop test
+project(interop_complex_test)
+add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)
+target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_23)
+target_link_libraries(${PROJECT_NAME} PRIVATE glaze_interop glaze_interop_client glaze::glaze ut::ut)
+if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+    target_compile_options(${PROJECT_NAME} PRIVATE -fno-exceptions -fno-rtti -Wall -Wextra -pedantic -Wno-missing-braces)
+endif()
+add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})
+
+# Member function interop test
+project(interop_member_function_test)
+add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)
+target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_23)
+target_link_libraries(${PROJECT_NAME} PRIVATE glaze_interop glaze_interop_client glaze::glaze ut::ut)
+if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+    target_compile_options(${PROJECT_NAME} PRIVATE -fno-exceptions -fno-rtti -Wall -Wextra -pedantic -Wno-missing-braces)
+endif()
+add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})
+
+# Zero copy interop test
+project(interop_zero_copy_test)
+add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)
+target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_23)
+target_link_libraries(${PROJECT_NAME} PRIVATE glaze_interop glaze_interop_client glaze::glaze ut::ut)
+if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+    target_compile_options(${PROJECT_NAME} PRIVATE -fno-exceptions -fno-rtti -Wall -Wextra -pedantic -Wno-missing-braces)
+endif()
+add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})
+
+# Core interop functionality test
+project(test_interop_core)
+add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)
+target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_23)
+target_link_libraries(${PROJECT_NAME} PRIVATE glaze_interop glaze_interop_client glaze::glaze ut::ut)
+if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+    target_compile_options(${PROJECT_NAME} PRIVATE -fno-exceptions -fno-rtti -Wall -Wextra -pedantic -Wno-missing-braces)
+endif()
+add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== tests/networking_tests/asio_repe/CMakeLists.txt ===
project(asio_repe)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_exceptions)

=== debian/changelog ===
glaze (5.7.2-1) unstable; urgency=medium

  * New upstream release.

 -- Carl Keinath <carl.keinath@gmail.com>  Sun, 28 Sep 2025 08:47:39 +0200

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,8 @@
  cmake
 Standards-Version: 4.7.2
 Homepage: https://github.com/stephenberry/glaze/tree/main
-Vcs-Browser: https://salsa.debian.org/debian/glaze
-Vcs-Git: https://salsa.debian.org/debian/glaze.git
+Vcs-Browser: https://salsa.debian.org/carlo711/glaze
+Vcs-Git: https://salsa.debian.org/carlo711/glaze.git
 Description: High-performance C++ JSON serialization library
  Glaze is a high-performance C++ library for JSON and other structured formats,
  it provides efficient serialization and deserialization.

## glaze 6.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 project(
     glaze
-    VERSION 5.7.2
+    VERSION 6.0.0
     LANGUAGES CXX
 )
 
@@ -93,8 +93,3 @@
   target_compile_definitions(glaze_glaze INTERFACE GLZ_ENABLE_SSL)
 endif(glaze_ENABLE_SSL)
 
-option(glaze_BUILD_INTEROP "Build language interoperability library" OFF)
-
-if(glaze_BUILD_INTEROP)
-  add_subdirectory(src/interop)
-endif()

=== examples/CMakeLists.txt ===
project(jsonrpc_example)
add_executable(json-rpc EXCLUDE_FROM_ALL)
target_sources(json-rpc PRIVATE json-rpc.cpp)
target_link_libraries( json-rpc PRIVATE glaze::glaze)

=== fuzzing/CMakeLists.txt ===

# this library provides main() for compilers that do not have libfuzzer (everyone except clang)
# so the source code is compiled regardless of compiler, which prevents code rot.
# also, the library provides a way to invoke the fuzzer on external data which is
# useful to run the fuzz corpus through code also when not using clang.
add_library(main STATIC main.cpp)
target_compile_features(main PRIVATE cxx_std_23)

# see if libfuzzer is supported - this gets more complicated than just checking
# for clang, because apple clang does not seem to support it and windows also
# support clang nowadays (and perhaps libfuzzer)

include(CheckSourceCompiles)
set(CMAKE_REQUIRED_LINK_OPTIONS -fsanitize=fuzzer)
check_source_compiles(CXX "
    #include <cstddef>
    #include <cstdint>
    extern \"C\" int LLVMFuzzerTestOneInput(const uint8_t* Data, size_t Size)
    { return 0;}
    " haslibfuzzer)


macro(create_fuzztest testname)
    add_executable(fuzz_${testname} ${testname}.cpp)
    target_link_libraries(fuzz_${testname} PRIVATE glaze::glaze)

    if(haslibfuzzer)
        target_compile_options(fuzz_${testname} PUBLIC -fsanitize=fuzzer)
        target_link_options(fuzz_${testname} PUBLIC -fsanitize=fuzzer)
    else()
        # supply a separate main
        target_link_libraries(fuzz_${testname} PRIVATE main)
    endif()

    if(CMAKE_CXX_COMPILER_ID MATCHES "Clang|GNU")
        target_compile_options(fuzz_${testname} PUBLIC -fsanitize=address,undefined -fno-sanitize-recover=all )
        target_link_options(fuzz_${testname} PUBLIC -fsanitize=address,undefined -fno-sanitize-recover=all )
    else()
        target_link_libraries(fuzz_${testname} PRIVATE main)
    endif()
endmacro()

create_fuzztest(binary_reflection)
create_fuzztest(csv_parsing)
create_fuzztest(json_generic)
create_fuzztest(json_jmespath)
create_fuzztest(json_minify)
create_fuzztest(json_prettify)
create_fuzztest(json_reflection)
create_fuzztest(json_roundtrip_floating)
create_fuzztest(json_roundtrip_int)
create_fuzztest(json_roundtrip_string)
create_fuzztest(json_with_comments)

macro(create_exhaustive_test testname)
    add_executable(${testname} ${testname}.cpp)
    target_link_libraries(${testname} PRIVATE glaze::glaze)
    # do not set sanitizers here - CI needs to run as fast as possible,
    # manual running may want sanitizers and debug.
    if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
        #target_compile_options(${testname} PRIVATE -O2)
        #target_compile_options(${testname} PRIVATE -fsanitize=address,undefined  -fno-sanitize-recover=all )
        #target_link_options(${testname} PRIVATE -fsanitize=address,undefined  -fno-sanitize-recover=all )
    endif()
endmacro()

create_exhaustive_test(json_exhaustive_roundtrip_int)
create_exhaustive_test(json_exhaustive_roundtrip_float)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -89,10 +89,6 @@
     add_subdirectory(eetf_test)
 endif(glaze_EETF_FORMAT)
 
-if(glaze_BUILD_INTEROP)
-    add_subdirectory(interop)
-endif(glaze_BUILD_INTEROP)
-
 # We don't run find_package_test or glaze-install_test with MSVC/Windows, because the Github action runner often chokes
 # Don't run find_package on Clang, because Linux runs with Clang try to use GCC standard library and have errors before Clang 18
 if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
@@ -131,4 +127,3 @@
     set_tests_properties(glaze-install_test PROPERTIES FIXTURES_SETUP glaze-install-fixture)
     set_tests_properties(find_package_test PROPERTIES FIXTURES_REQUIRED glaze-install-fixture)
 endif()
-

=== tests/cli_menu_test/CMakeLists.txt ===
project(cli_menu_test)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_common)

=== tests/compare_test/CMakeLists.txt ===
project(compare_test)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_common)

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== tests/exceptions_test/CMakeLists.txt ===
project(exceptions_test)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_exceptions)

if (MINGW)
    target_compile_options(${PROJECT_NAME} PRIVATE "-Wa,-mbig-obj")
endif ()

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

target_code_coverage(${PROJECT_NAME} AUTO ALL)

=== tests/inplace_vector/CMakeLists.txt ===
project(inplace_vector_test)

add_executable(${PROJECT_NAME} inplace_vector_test.cpp)
target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_exceptions)

add_executable(${PROJECT_NAME}_noexceptions inplace_vector_test.cpp)
target_link_libraries(${PROJECT_NAME}_noexceptions PRIVATE glz_test_common)

if (MINGW)
    target_compile_options(${PROJECT_NAME} PRIVATE "-Wa,-mbig-obj")
    target_compile_options(${PROJECT_NAME}_noexceptions PRIVATE "-Wa,-mbig-obj")
endif ()

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})
add_test(NAME ${PROJECT_NAME}_noexceptions COMMAND ${PROJECT_NAME}_noexceptions)

target_code_coverage(${PROJECT_NAME} AUTO ALL)

=== tests/json_conformance/CMakeLists.txt ===
project(json_conformance)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_common)

if (MINGW)
    target_compile_options(${PROJECT_NAME} PRIVATE "-Wa,-mbig-obj")
endif ()

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

target_code_coverage(${PROJECT_NAME} AUTO ALL)

=== tests/json_test/CMakeLists.txt ===
--- 
+++ 
@@ -28,7 +28,7 @@
 
 add_test(NAME ${PROJECT_NAME}_non_null COMMAND ${PROJECT_NAME}_non_null)
 
-## glz::json_t test
+## glz::generic test
 
 add_executable(json_t_test json_t_test.cpp)

=== tests/jsonrpc_test/CMakeLists.txt ===
project(jsonrpc_test)

add_executable(jsonrpc_test jsonrpc_test.cpp)

target_link_libraries(jsonrpc_test PRIVATE glz_test_common)

add_test(NAME jsonrpc_test COMMAND jsonrpc_test)

=== tests/networking_tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,21 @@
-FetchContent_Declare(
-    asio
-    GIT_REPOSITORY https://github.com/chriskohlhoff/asio.git
-    GIT_TAG asio-1-32-0
-    GIT_SHALLOW TRUE
-)
-FetchContent_MakeAvailable(asio)
+find_package(Boost QUIET CONFIG COMPONENTS system)
+
+if(Boost_FOUND)
+    add_library(glz_asio INTERFACE)
+    target_link_libraries(glz_asio INTERFACE Boost::system)
+    target_compile_definitions(glz_asio INTERFACE BOOST_ASIO_DYN_LINK)
+else()
+    FetchContent_Declare(
+        asio
+        GIT_REPOSITORY https://github.com/chriskohlhoff/asio.git
+        GIT_TAG asio-1-32-0
+        GIT_SHALLOW TRUE
+    )
+    FetchContent_MakeAvailable(asio)
+    add_library(glz_asio INTERFACE)
+    target_include_directories(glz_asio INTERFACE ${asio_SOURCE_DIR}/asio/include)
+endif()
+
 
 # HTTP Examples
 add_subdirectory(http_examples)

=== debian/changelog ===
glaze (6.0.0-1) unstable; urgency=medium

  * New upstream release
  * distribute upstreams documentation via libglaze-doc
  * d/control:
    + depend on mkdocs
    + new binary libglaze-doc

 -- Carl Keinath <carl.keinath@gmail.com>  Tue, 14 Oct 2025 20:21:21 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,10 @@
 Maintainer: Carl Keinath <carl.keinath@gmail.com>
 Build-Depends:
  debhelper-compat (= 13),
- cmake
+ cmake,
+ mkdocs <!nodoc>,
+ mkdocs-material <!nodoc>,
+ mkdocs-autorefs <!nodoc>,
 Standards-Version: 4.7.2
 Homepage: https://github.com/stephenberry/glaze/tree/main
 Vcs-Browser: https://salsa.debian.org/carlo711/glaze
@@ -19,7 +22,21 @@
 Multi-Arch: foreign
 Depends:
  ${misc:Depends},
+Suggests: libglaze-doc
 Description: ${source:Synopsis} - development files
  ${source:Extended-Description}
  .
  Note: This package only supports little-endian systems.
+
+Package: libglaze-doc
+Section: doc
+Architecture: all
+Multi-Arch: foreign
+Build-Profiles: <!nodoc>
+Depends:
+ ${misc:Depends},
+ ${mkdocs:Depends},
+Description: ${source:Synopsis} (documentation)
+ ${source:Extended-Description}
+ .
+ This package installs the common documentation package.

=== debian/rules ===
--- 
+++ 
@@ -9,3 +9,10 @@
 	dh_auto_configure -- \
 	-Dglaze_DEVELOPER_MODE=OFF \
 	-DBUILD_TESTING=OFF
+
+execute_after_dh_auto_build:
+ifeq ($(filter nodoc,$(DEB_BUILD_OPTIONS)),)
+	mkdocs build -d docs.debian/html
+	find docs.debian -type f -exec sed -i 's|<link [^>]*href="http[^>]*>||g' '{}' ';'
+	find docs.debian -type f -exec sed -i -E 's|<img[^>]+src="https?://[^"]+"[^>]*/>||g' '{}' ';'
+endif

=== debian/watch ===
Version: 5

Template: Github
Owner: stephenberry
Project: glaze

## glaze 6.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 project(
     glaze
-    VERSION 6.0.0
+    VERSION 6.1.0
     LANGUAGES CXX
 )

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -3,3 +3,7 @@
 target_sources(json-rpc PRIVATE json-rpc.cpp)
 target_link_libraries( json-rpc PRIVATE glaze::glaze)
 
+add_executable(wrapping_middleware_example EXCLUDE_FROM_ALL)
+target_sources(wrapping_middleware_example PRIVATE wrapping_middleware_example.cpp)
+target_link_libraries(wrapping_middleware_example PRIVATE glaze::glaze)
+

=== tests/json_test/CMakeLists.txt ===
project(json_test)

set(JSON_TEST_SOURCES json_test.cpp)
set(JSON_VARIANT_SUPPORT_SOURCES json_variant_support_test.cpp)

function(add_glz_json_test target)
    add_executable(${target} ${ARGN})
    target_link_libraries(${target} PRIVATE glz_test_common)

    if (MINGW)
        target_compile_options(${target} PRIVATE "-Wa,-mbig-obj")
    endif ()

    add_test(NAME ${target} COMMAND ${target})

    target_code_coverage(${target} AUTO ALL)

    set(non_null_target ${target}_non_null)
    add_executable(${non_null_target} ${ARGN})
    target_compile_definitions(${non_null_target} PRIVATE GLZ_NULL_TERMINATED=false)
    target_link_libraries(${non_null_target} PRIVATE glz_test_common)

    if (MINGW)
        target_compile_options(${non_null_target} PRIVATE "-Wa,-mbig-obj")
    endif ()

    add_test(NAME ${non_null_target} COMMAND ${non_null_target})
endfunction()

add_glz_json_test(${PROJECT_NAME} ${JSON_TEST_SOURCES})
add_glz_json_test(json_variant_support_test ${JSON_VARIANT_SUPPORT_SOURCES})

## glz::generic test

add_executable(json_t_test generic_test.cpp)

target_link_libraries(json_t_test PRIVATE glz_test_common)

add_test(NAME json_t_test COMMAND json_t_test)

## JSON Schema test

add_executable(jsonschema_test jsonschema_test.cpp)

target_link_libraries(jsonschema_test PRIVATE glz_test_common)

add_test(NAME jsonschema_test COMMAND jsonschema_test)

## Variant ambiguous test - test for ambiguous variant handling

add_executable(variant_ambiguous_test variant_ambiguous_test.cpp)

target_link_libraries(variant_ambiguous_test PRIVATE glz_test_common)

add_test(NAME variant_ambiguous_test COMMAND variant_ambiguous_test)

## Value-based skip test - test for issue #1994

add_executable(value_based_skip_test value_based_skip_test.cpp)

target_link_libraries(value_based_skip_test PRIVATE glz_test_common)

add_test(NAME value_based_skip_test COMMAND value_based_skip_test)

## Nullable lambda test - tests that lambdas returning nullable types can be skipped

add_executable(nullable_lambda_test nullable_lambda_test.cpp)

target_link_libraries(nullable_lambda_test PRIVATE glz_test_common)

add_test(NAME nullable_lambda_test COMMAND nullable_lambda_test)

## Byte array test - test for issue #1959 and PR #1966

add_executable(byte_array_test byte_array_test.cpp)

target_link_libraries(byte_array_test PRIVATE glz_test_common)

add_test(NAME byte_array_test COMMAND byte_array_test)

=== tests/networking_tests/websocket_test/CMakeLists.txt ===
project(websocket_server)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_exceptions)

target_compile_definitions(${PROJECT_NAME} PRIVATE
    SOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}")

# WebSocket close and error handling tests
project(websocket_close_test)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_exceptions)

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

# WebSocket client tests
project(websocket_client_test)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_exceptions)

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

# UTF-8 validation tests
project(utf8_test)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_exceptions)

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== debian/changelog ===
glaze (6.1.0-1) unstable; urgency=medium

  * New upstream release
  * d/tests: add initial autopkgtest to verify basic functionality

 -- Carl Keinath <carl.keinath@gmail.com>  Sat, 29 Nov 2025 12:31:15 +0100

=== debian/tests/control ===
Tests: basic-test
Depends: @, cmake, g++
Architecture: !s390x
Restrictions: superficial
